<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, inject, computed } from 'vue';
import { useRouter, useRoute } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import * as jose from 'jose'
import Input from '@/components/general/form/Input.vue';
import { setCookie, validFullMail } from '@/lib/utils';
import { request } from '@/lib/request';
import { useAccountStore } from '@/stores/account';
import CreateAccountModal from '@/components/account/CreateAccountModal.vue';
import PasswordResetRequestModal from '@/components/account/PasswordResetRequestModal.vue';
import Button from '@/components/general/Button.vue';
import OverviewLoginLayout from '@/components/account/OverviewLoginLayout.vue';

const route = useRoute();
const router = useRouter();
const store = useAccountStore();
const { mail: accountMail, accesscode, canUseAI } = storeToRefs(store);
const configuration = inject<any>('configuration');
const apiServer = configuration.apiServer;

const mail = ref('');
const error = ref('');
const backendOffline = ref(false);
const password = ref('');
const { t } = useI18n();
const $t = t;
document.title = $t('login.title');

const handleCheckMail = async () => {
    let response = await request('POST', apiServer + '/api/account/checkmail', { mail: mail.value.toLocaleLowerCase() });
    if (response && response.success) {
        showPasswordField.value = true;
    } else {
        showAccountCreateModal(true);
    }
};

const handleLogin = async () => {
    error.value = '';
    let response = await request('POST', apiServer + '/api/account/login', { password: password.value, mail: mail.value.toLocaleLowerCase() });
    if (response && response.success && response.token) {
        setCookie(response.token, configuration.basePath);
        accountMail.value = mail.value.toLocaleLowerCase();
        const payload = jose.UnsecuredJWT.decode(response.token);
        accesscode.value = String(payload.payload.accesscode);
        canUseAI.value = Boolean(payload.payload.canUseAI);
        if (route.redirectedFrom) {
            router.push(route.redirectedFrom);
        } else if (window.history.state.back) {
            router.back();
        } else {
            router.push({ name: 'overview-account' });
        }
    } else {
        error.value = $t('general.variables.password.error');
    }
}

const handleAccountCreateModal = (value: boolean)=>{
    showAccountCreateModal(false);
    if(value){
        redirectCreateAccount();
    }
}

const handleRequestPasswordReset = () => {
    showPasswordResetModal(true);
}

const redirectCreateAccount = () => {
    router.push({ name: "registration" });
}

const showPasswordField = ref(false);
const handleReEnterMail = () => {
    showPasswordField.value = false;
}

const isAccountCreateModalOpen = ref(false);
const showAccountCreateModal = (value: boolean) => {
    isAccountCreateModalOpen.value = value;
}

const isPasswordResetModalOpen = ref(false);
const showPasswordResetModal = (value: boolean) => {
    isPasswordResetModalOpen.value = value;
}

const validMail = computed(() => {
    return validFullMail(mail.value);
});

</script>
<template>
    <div class="h-full">
        <div class="flex box-content max-w-xl mx-auto px-4 h-full items-center">
            <div class="relative box-border transition duration-100 ease-in-out rounded-lg w-full bg-white shadow-md">
                <div class="p-4 flex flex-col gap-2">
                    <h4 class="text-center text-2xl text-gray-500">{{ $t('login.title') }}</h4>
                    <strong class="text-red-600" v-if="error">{{ error }}</strong>
                    <div class="w-full mt-4">
                        <Transition name="slide-fade" mode="out-in">
                            <form @submit.prevent="">
                                <Input id="user-text-field" v-model="mail" type="mail" icon="mail"
                                    :placeholder="$t('placeholder.mail')"
                                    autocomplete="username" @keyup.enter="handleCheckMail" v-show="!showPasswordField"
                                    :autofocus="true" />
                                <div v-show="showPasswordField">
                                    <p class="flex flex-row gap-1"><span class="text-xs">{{ mail }}</span>
                                        <Tooltip :tooltip="$t('general.variables.change')">
                                            <div class="cursor-pointer hover:bg-gray-100 rounded-full size-4 p-1"
                                                @click.stop.prevent="handleReEnterMail"><i
                                                    class="ri-pencil-line absolute -mt-1.5 -ml-0.5"></i></div>
                                        </Tooltip>
                                    </p>
                                    <Input id="password-text-field" v-model="password" type="password" icon="key"
                                        :label="$t('placeholder.password')" :placeholder="$t('placeholder.password')"
                                        autocomplete="current-password" @keyup.enter="handleLogin" />
                                </div>
                            </form>
                        </Transition>
                        <div class="mt-2">
                            <Button :variant="validMail ? 'confirm' : 'disabled'" @click="handleCheckMail"
                                v-if="!showPasswordField">{{ $t("general.buttons.next") }}</Button>
                            <Button :variant="password && password.length >= 8 ? 'confirm' : 'disabled'" @click="handleLogin"
                                v-else-if="showPasswordField">{{
                                    $t("adminMenu.passwordReset.submit") }}</Button>
                        </div>
                        <div class="mt-2 mb-2">
                            <a class="text-center w-full block align-middle select-none cursor-pointer"
                                @click="handleRequestPasswordReset"> {{
                                    $t("adminMenu.passwordReset.label") }} </a>
                        </div>
                    </div>
                    <Button variant="accent2" :to="$t('indexPage.buttonTexts.help.url')">{{
                            $t("indexPage.buttonTexts.help.label") }}</Button>
                </div>
            </div>
            <CreateAccountModal v-if="isAccountCreateModalOpen" @close="handleAccountCreateModal" />
            <PasswordResetRequestModal v-if="isPasswordResetModalOpen" @close="showPasswordResetModal(false)" />
        </div>
    </div>
</template>
<style scoped>
@media (min-width: 500px) {
    .container {
        max-width: 500px;
        min-width: 500px;
    }
}

.slide-fade-enter-active {
    transition: all 0.3s ease-out;
}

.slide-fadel-leave-active {
    transition: all 0.1s cubic-bezier(1, 0.5, 0.8, 1);
}

.slide-fade-enter-from,
.slide-fade-leave-to {
    transform: translateX(20px);
    opacity: 0;
}
</style>